               JOB
               CTL  6611
     *
     * Subscript routine, entered from arithmetic interpreter with
     * 0&x2 = $, 3&x2 = array base, 6&6n&x2 = subscript address,
     * 9&6n&x2 = per-subscript address.  Subscript address and per-
     * subscript address are repeated until 10&6n&x2 is $.  For one-
     * dimensional arrays, per-subscript size is element size.  For
     * two-dimensional arrays, per-subscript sizes are element size
     * times column size, then element size, etc.
     *
     * On exit, subscripted element address is in x1, and X2
     * references interpreter string character after terminating $.
     *
     x1        equ  89
     x2        equ  94
     *
               ORG  2000
 2000subs      SBR  exit&3     Store return
 2004          MCW  3&X2,a3    Get 3-character array base address
 2011          S    a5         Clear subscripting offset
 2015          BAV  *&1        Turn off overflow
     *
     * Compute sum of products of per-subscript sizes and subscripts.
     *
 2020again     MCW  9&X2,getsiz&3  Get element size address
 2027          MCW  6&X2,getsub&3  Get subscript address
 2034getsub    ZA   0-0,s5     Get subscript
 2041getsiz    LCA  0-0,w5     Get element size
 2048          M    s5,work    Multiply element size by subscript 
 2055          A    work,a5    Add product to offset
 2062          C    a5-3,k15   Too big
 2069          BL   toobig     Offset 15999
 2074          BCE  conv,10&X2,$  Done?  Convert offset to 3-characters
 2082          SBR  x2,6&X2    Bump to next per-subscript & subscript
 2089          B    again      Get next pair
     *
     * Convert offset to three character address
     *
 2093conv      A    kp96,a5-3  Convert thousands div 4 to
 2100          BAV  conv         overflow zones
 2105          MZ   a5-4,a5    Overflow zones to low-order
 2112          ZA   a5-2,x1&1  Thousands mod 4 to X1
 2119          MZ   zones-99&X1,a5-2  a5-2..15 is now 3-char offset
     *
     * Do the subscripting
     *
 2126          MCW  a5,x1      Move 3-character offset into x1 and
 2133          MCW  x1,dosub&6   instruction that does subscripting
     *                         This is done in two steps to avoid
     *                         needing to set and clear word marks
 2140          MZ   zones-2,dosub&5  Put x1 zone in B-addr
 2147          MCW  a3,x1      Put base address into x1
 2154dosub     SBR  x1,0-0&X1  Do the subscripting
 2161          MZ   a3-1,x1-1  Restore type zone in tens digit
 2168          SBR  x2,11&X2   Get past end of subscripts
 2175exit      B    0-0        Exit
     *
     * Offset is greater than 15999
     *
 2179toobig    NOP  2002
 2183          H
 2184          B    toobig
     *
     * Data
     *
 2191zones     dcw  @2SKB@  Used for 3-character to 5-digit conversion
 2194a3        DCW  #3  3-character array base address
 2199a5        DCW  #5  sum of products of per-subscript & subscript
 2204s5        DCW  #5  subscript
 2209w5        dcw  #5  product of one per-subscript size
 2215work      DC   #6    and its corresponding subscript
 2217k15       dcw  15  Largest thousands & ten-thousands offset
 2219kp96      DCW  &96  Used for 3-character to 5-digit conversion
               end
